summaryrefslogtreecommitdiff
path: root/tests/cp/fiemap-perf.sh
diff options
context:
space:
mode:
authorStefano Lattarini <stefano.lattarini@gmail.com>2012-08-30 14:13:12 +0200
committerJim Meyering <meyering@redhat.com>2012-08-30 18:55:59 +0200
commit9eb4c31eb78c28dd9f72d1cbb940270311be343c (patch)
treeea3078bc1b002a9f948ed41445ca32318002a1d3 /tests/cp/fiemap-perf.sh
parent00f5ba15dd91a3d9780fe1fbd06a4df436ae6714 (diff)
downloadcoreutils-9eb4c31eb78c28dd9f72d1cbb940270311be343c.tar.xz
tests: add .sh and .pl suffixes to shell and perl tests, respectively
Not only this shrinks the size of the generated Makefile (from > 6300 lines to ~3000), but will allow further simplifications in future changes. * tests/Makefile.am (TEST_EXTENSIONS): Add '.sh' and '.pl'. (PL_LOG_COMPILER, SH_LOG_COMPILER): New, still defined simply to $(LOG_COMPILER) for the time being. (TESTS, root_tests): Adjust as described. * All tests: Rename as described.
Diffstat (limited to 'tests/cp/fiemap-perf.sh')
-rwxr-xr-xtests/cp/fiemap-perf.sh49
1 files changed, 49 insertions, 0 deletions
diff --git a/tests/cp/fiemap-perf.sh b/tests/cp/fiemap-perf.sh
new file mode 100755
index 000000000..ca093b5a0
--- /dev/null
+++ b/tests/cp/fiemap-perf.sh
@@ -0,0 +1,49 @@
+#!/bin/sh
+# ensure that a sparse file is copied efficiently, by default
+
+# Copyright (C) 2011-2012 Free Software Foundation, Inc.
+
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+
+. "${srcdir=.}/init.sh"; path_prepend_ ../src
+print_ver_ cp
+
+# Require a fiemap-enabled FS.
+touch fiemap_chk
+fiemap_capable_ fiemap_chk ||
+ skip_ "this file system lacks FIEMAP support"
+
+# Exclude ext[23] (or unknown fs types)
+# as the emulated extent scanning can be slow
+df -t ext2 -t ext3 . >/dev/null &&
+ skip_ "ext[23] can have slow FIEMAP scanning"
+
+# Create a large-but-sparse file.
+timeout 10 truncate -s1T f ||
+ skip_ "unable to create a 1 TiB sparse file"
+
+# Disable this test on old BTRFS (e.g. Fedora 14)
+# which reports (unwritten) extents for holes.
+filefrag f || skip_ 'the 'filefrag' utility is missing'
+filefrag f | grep -F ': 0 extents found' > /dev/null ||
+ skip_ 'this file system reports extents for holes'
+
+# Nothing can read (much less write) that many bytes in so little time.
+timeout 10 cp f f2 || fail=1
+
+# Ensure that the sparse file copied through fiemap has the same size
+# in bytes as the original.
+test "$(stat --printf %s f)" = "$(stat --printf %s f2)" || fail=1
+
+Exit $fail